-- ====================================================================================
-- Example of Ada Abstract Class Declaration
-- 
-- For Ada Distilled by Richard Riehle
-- ====================================================================================
--
--
package Abstract_Machinery_1 is	                   --  1  An Ada Module
   type Machine is abstract tagged private;            --  2  Machine is now abstract
   type Reference is access all Machine'Class;         --  3  A classwide access type
   procedure Turn_On (M : in out Machine);	       --  5  Turn on the machine
   procedure Turn_Off (M : in out Machine);	       --  6  Turn off the Machine
   function Is_On  (M : Machine) return Boolean;       --  7  Is the Machine turned on?
private			                               --  8  Begin private part of package
   type Machine is abstract tagged                     --  9  A full definition of the record
      record                                           -- 10  reserved word in good formatting
         Is_On : Boolean := False;                     -- 11  Machine content; initialized 
      end record;                                      -- 12 End of machine definition
end Abstract_Machinery_1;	                         -- 13 End of the package specification