-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Array_Of_Procedures.adb
--
-- See 5.4.2.1 in Ada Distilled for discussion of this program.
--
-- 
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
with Ada.Integer_Text_Io;	                                    --  1 ALRM Annex A
with Ada.Text_Io;	                                                --  2 ALRM Annex A
use  Ada;		                                                --  3 Makes Ada directly visible
procedure Array_Of_Procedures is	                              --  4 Name of enclosing procedure
   type Action is access procedure (Data : in out Integer);	      --  5 Access to subprogram definition
   procedure Process (D : in out Integer) is                      --  6 Procedure with correct profile
   begin		                                                --  7 
      D := D + D;	                                                --  8 Details;  procedure behavior
   end Process;	                                                --  9 end of scope of procedure
   type Process_Set is array (1 .. 10) of Action;    	            -- 10 Array type  of access types 
   Index :  Positive;	                                          -- 11 Used for array index later
   Value :  Integer := 0;	                                    -- 12 Used for actual parameter 
   The_Process : Process_Set := (others => Process'access);       -- 13 access object array with aggregate
begin			                                                -- 14 
   loop		                                                -- 15	
      Text_Io.Put("Enter Index(1..10): ");	                  -- 16 
      Integer_Text_Io.Get(Index);	                              -- 17 
      exit when Index not in 1..10;	                              -- 18 membership test for exit
      Text_Io.New_Line;	                                          -- 19 
      Text_Io.Put("Enter Integer Value: ");	                  -- 20 
      Integer_Text_Io.Get(Value);	                              -- 21 
      The_Process(Index)(Data => Value);                          -- 22 Named association clarifies
      Text_Io.New_Line;	                                          -- 23 
      Text_Io.Put("The result for Index " & Positive'Image(Index)	-- 24 
         & "is"  & Integer'Image(Value));	                        -- 25 
   end loop;	                                                -- 26 
end Array_Of_Procedures;	                                    -- 27 