-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Block_Example_2.adb
--
-- See 4.2.1 in Ada Distilled for discussion of the case statements.
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- ==========================================================================================
--
with Ada.Text_Io;		                              --   1  Put a library unit in scope
procedure Block_Example_2 is
  procedure Tip_A is     	                        --   2  Parameterless declaration
     Rare_E : Float := 2.72; -- natural number, e	--   3  A rare E; see ALRM A.5
     Data : Integer := 42;	                        --   4  In scope for entire procedure
  begin				                        --   5  Required to initiate sequence of statements
     Ada.Text_Io.Put(Integer'Image(Data));            --   6  What will print? Integer is converted to a string
     declare			                        --   7  begin a new scope (declarative region)
       Data : Float := 3.14; -- a short slice of pi	--   8  Hide visibility of Integer, Data; see ALRM A.5
     begin			                              --   9  [optionally Handled ] sequence of statements
       Ada.Text_Io.Put(Float'Image(Data));            --  10 X'Image is allowed for Floating Point
     end;			                              --  11 A scope terminator is required
       Ada.Text_Io.Put(Float'Image(Rare_E));          --  12 A long way to tip a rare e.
  end Tip_A;			                        --  13 Always include a unit name
begin
   Tip_A;
end Block_Example_2;
