-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Block_Example_3.adb
--
-- See 4.2.1 in Ada Distilled for discussion of the case statements.
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- ==========================================================================================
--
with Ada.Text_IO;	                                    --  1  Put a library unit in scope
with Ada.Integer_Text_Io, Ada.Float_Text_IO;          --  2 Predefined numeric IO packages
with Ada.Numerics;	                              --  3 ALRM, Annex A.5
use  Ada.Integer_Text_IO;
procedure Block_Example_3 is

   procedure P7 is		                        --  4 Parameterless declaration
      package IIO renames Ada.Integer_Text_IO;        --  5 Make the name shorter via a renames clause
      X : Integer := 42;	                        --  6 In scope for entire procedure
   begin				                        --  7 Required to initiate sequence of statements
      Iio.Put(X);		                              --  8 What will print?
      Local_Block:	                              --  9 Always name a declare block
         declare			                        -- 10 begin a new scope (declarative region)
         use Ada.Float_Text_IO;                     -- 11 controversial localization of use clause
         X : Float := Ada.Numerics.Pi;                -- 12 Hide visibility of global Integer, P7.X
      begin			                              -- 13 [optionally Handled ] sequence of statements
         Put(X);		                              -- 14 Put is visible because of  "use clause"
         IIO.Put(P7.X);	                              -- 15 Dot qualifier  makes Integer X visible
      end Local_Block;	                              -- 16 Labeled end  name required for labeled block
   end P7;				                        -- 17 Always label a subprogram end statement

begin
   P7;
end Block_Example_3;
