-- ==========================================================================================
-- Case_Example_1.adb
--
-- See 4.2.3 in Ada Distilled for discussion of the case statements
--  
--
--
--
-- ==========================================================================================
--
procedure Case_Example_1 is
   type Color is 
         (White,      
          Red,        
          Orange,     
          Yellow,     
          Chartreuse, 
          Green,      -- The values are the names of the colors
          Blue,       
          Indigo,     
          Violet,     
          Black,      
          Brown); -- No need for numerics
          
   type Value is new Integer range 0..5;       
   -- The Following function Evaluates Many of The Alternatives.

      function Evaluate (C : Color) return  Value is --  1 Simple function declaration
           Result : Value := Value'First;            --  2 Local variable
      begin	-- Evaluate	                             --  3 Comment the begin statement
      case C is	                                   --  4 Start a case statement
         when Red => Result := 1;	                 --  5 The => is an association symbol
         when Blue =>Result := 2;	                 --  6 Am I blue? Set result to 2
         when Black .. Brown => Result := 3;         --  7 For black through brown ...
         when Orange | Indigo => Result := 4;        --  8 For either orange or indigo
         when  others => Result := 5;                --  9 others required for unspecified cases.
      end case;	                                   -- 10 Must use others if any cases are not specified
      return Result;	                             -- 11 Compiler will look for a return statement
   end Evaluate;	                                   -- 12 As usual, label the end statement

begin
   null;
end Case_Example_1;  