-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Compute_Trigs.ads
--
-- See      in Ada Distilled for discussion of this program.
--
-- 
--
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
with Ada.Text_Io;	                               --   1 Put Text_IO library unit in scope; 	10.1.2, A.10
with Ada.Float_Text_Io;	                         --   2 A.10.9/33
with Ada.Numerics.Generic_Elementary_Functions;	 --   3 A.5.1
use Ada;			                         --   4 Gives direct visibility to all of package Ada	8.4
procedure  Compute_Trigs  is	                   --   5 Parameterless declaration; 	6.3
   package Compute is new Ada.	             --   6 A.2  A new instance with a new name
      Numerics.	                               --   7 A.5 Root package for numerics 
      Generic_Elementary_Functions               --   8 A.5.1  Contains Trig and other functions
      (Float_Type => Float);	                   --   9 A.1/25 for definition of type Float
   Pi  : Float := Ada.Numerics.Pi;	             --  10 Pi is defined in Ada.Numerics	
   Radius : Float := 12.0;	                   --  11 Ordinary Floating point initialized	
   Area : Float := 0.0;                          --  12 I prefer to initialize variables; not required here
   Sqrt_Result : Float := 0.0;	             --  13 For our Square root computation
begin				                         --  14 Begins sequence of algorithmic statements; 	6.3
   Area := Pi* Radius ** 2;	                   --  15 Compute the area of the circle
   Ada.Float_Text_Io.Put(Area);                  --  16 dot notation makes Put visible	A.10.6
   Sqrt_Result := Compute.Sqrt(Area);            --  17 Note use of Compute with dot notation
end Compute_Trigs;	                         --  18 Scope terminator with name of unit	6.3