-- ====================================================================================
-- Ada Distilled 
--
-- ====================================================================================
with Machinery, Rotating_Machinery;	                  --  1  Context clause 
with Ada.Integer_Text_Io;	                        --  2  Enables the input of the array index
procedure Dynamic_Binding_Example_1 is                --  3  Specification for the example procedure
   Data : array (1..2) of Machinery.Reference := 	--  4
      (1 => new Machinery.Machine, 	                  --  5
       2 => new Rotating_Machinery.Rotational);	      --  6
   Index : Natural range 0..2 := 0;                   --  7  Use this to index into the array
begin				                              --  8  
   Ada.Integer_Text_Io.Get(Index);                   --  9  Get the index for the next statement 
   Machinery.Turn_On(Data(Index).all);                -- 10 Dynamically call one of the Turn_On methods
end Dynamic_Binding_Example_1;	                  -- 11