with Ada.Exceptions;	                                   --  1 Chapter 11.4.1 ALRM; also, see the end of this chapter
with Ada.Text_Io;                                          --  2
use  Ada;	                                               --  3 OK for use clause on package Ada
with Ohm;                                                  --  4
procedure  Electric (Amp, Volt : in Float;  	           --  5 In parameters
      Resistance : out Float)  is	                       --  6  Out parameter; 	6.3
   function Msg (X : Exceptions.Exception_Occurrence)      --  5 Profile for Exception_Message function
      return String	                                   --  6 Return type for Exception_Message
      renames Exceptions.Exception_Message;                --  7 Rename it to three character  function name
begin		                                               --  8 Begins sequence of algorithmic statements; 	6.3
   Resistance := Ohm(Amp => Amp, Volt => Volt);            --  9 Simple division operation; cannot divide by zero
exception	                                               -- 10 If we try to divide by zero, land here.
   when Electric_Error:                                    -- 11 data type is Ada.Exceptions.Exception_Occurrence
         Constraint_Error =>                               -- 12 This error is raised on divide-by-zero; handle it here.
      Text_Io.Put_Line(Msg(Electric_Error));               -- 13 See lines 5-7;  renamed Exception_Message function
      Exceptions.Reraise_Occurrence(Electric_Error);       -- 14 Procedure for re-raising the exception by occurrence name
end Electric;	                                         -- 15 Scope terminator with name of unit	6.3