with Ada.Text_IO;
use  Ada;
procedure Floating_Point_Attributes is

  type Real is digits 12 range -32_000.0 .. +32_000.0;
  for Real'Size use 64;
  package Real_IO is new Text_IO.Float_IO(Num => Real);
  
  Number_1 : Real := 87.033444;
  Number_2 : Real := 2033.3452;
  Result   : Real := 0.0;
  Temp     : Real := 0.0;

begin
  -- Adjacent Attribute
  Result := Real'Adjacent(Real'First, Real'Last);
  Text_IO.Put("Real'Adjacent(Real'First) = ");
  Real_IO.Put(Result, 6, 3, 0);
  Text_IO.Put("  Real'First = ");
  Real_IO.Put(Real'First, 6, 3, 0);
  Text_IO.New_Line;
  
  -- Ceiling Attribute
  Result := Real'Ceiling(Number_1);
  Text_IO.Put("Real'Ceiling of 87.033444 = ");
  Real_IO.Put(Result, 6, 3, 0);
  Text_IO.New_Line;
  
  -- Compose Attribute
  Result := Real'Compose(32.0, 5);
  Text_IO.Put("Real'Compose(32.0, 5) = ");
  Real_IO.Put(Result, 6, 3, 0);
  Text_IO.New_Line;

  
null;



end Floating_Point_Attributes;