-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Function_Access_Type.adb
--
-- See 5.4.4.2 in Ada Distilled for discussion of this program.
--
-- This will not compile because of the attempt to violate accessibility rules on line 8
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
with Ada.Text_Io; use Ada;                                                   --  1  		
procedure Function_Access_Type is	                                         --  2 
    type Real is digits 12;                                                  --  3 Define a floating point type
    package Fio is new Text_Io.Float_Io(Num => Real);                        --  4 Instantiate IO package
    function Method (D : in Real) return Real is                             --  5 function w/correct profile
    begin		                                                           --  6 
       return D + D;	                                                     --  7 
    end Method;	                                                           --  8 
    type Compute is access function (D : in Real) return Real;	           --  9 Corresponding access type
    Result, Value :  Real := 0.0;	                                         -- 10 
    procedure Process (Behavior : Compute; Input  : in  Real;                -- 11 Note first parameter type
      Output : out Real) is	                                               -- 12 
  begin		                                                           -- 13 
     Output := Behavior(Input);	                                         -- 14 Reference to a function
  end Process;	                                                           -- 15 
begin			                                                           -- 16 
   loop		                                                           -- 17 	
      Text_Io.New_Line;	                                                     -- 18 
      Text_Io.Put("Enter Real Value (0 to exit): ");	                       -- 19 
      Fio.Get(Value);	                                                     -- 20 
      exit when Value = 0.0;  	                                         -- 21 
      Process(Behavior => Method'access, Input => Value, Output => Result);  -- 22 Key statement in this example
      Text_Io.New_Line;	                                                     -- 23 
      Text_Io.Put_Line("The result is ");	                                   -- 24 
      Fio.Put(Result, Fore => 4, Aft => 3, Exp => 0);	                       -- 25 
      Text_Io.New_Line;	                                                     -- 26 
   end loop;  	                                                           -- 27 
end Function_Access_Type;	                                               -- 28 