-- ====================================================================================
-- Ada Distilled 
--
-- ====================================================================================
package Machinery is	                          --  1  An Ada Module
   type Machine is tagged private;                --  2  A tagged  partial definition of message
   type Reference is access all Machine'Class;    --  3  A classwide access type
   procedure Turn_On (M : in out Machine);	  --  5  Turn on the machine
   procedure Turn_Off (M : in out Machine);  	  --  6  Turn off the Machine
   function Is_On  (M : Machine) return Boolean;  --  7 Is the Machine turned on?
private			                          --  8  Begin private part of package
   type Machine is tagged                         --  9 Full tagged definition of message
      record                                      -- 10
         Is_On : Boolean := False;                -- 11  Machine content; initialized 
      end record;                                 -- 12 End of machine definition
end Machinery;	                                -- 13 End of the package specification