-- =================================================
-- Ada Distilled 
-- Machinery_For_Streams.ads
-- =================================================
package Machinery_For_Streams is	                  --  1  An Ada Module
   type Machine is abstract tagged private;           --  2  A tagged  partial definition of message
   type Reference is access all Machine'Class;        --  3  A classwide access type
   type Machine_Set is array(Positive range <>)
                  of Reference;
   procedure Turn_On  (M : in out Machine);	      --  5  Turn on the machine
   procedure Turn_Off (M : in out Machine);  	      --  6  Turn off the Machine
   function Is_On  (M : Machine) return Boolean;      --  7 Is the Machine turned on?
   type Machine_1 is new Machine with private;        --  2  
   function Create(S : String := "Machn_1") return Machine_1;  
   procedure Turn_On  (M1 : in out Machine_1);	      --  5  Turn on the machine
   procedure Turn_Off (M1 : in out Machine_1);        --  6  Turn off the Machine
   type Machine_2 is new Machine with private;        --  2 
   function Create(S : String := "Machn_2") return Machine_2; 
   procedure Turn_On  (M2 : in out Machine_2);	      --  5  Turn on the machine
   procedure Turn_Off (M2 : in out Machine_2);        --  6  Turn off the Machine
   type Machine_3 is new Machine_1 with private;      --  2 
   function Create(S : String := "Machn_3") return Machine_3; 
   procedure Turn_On  (M3 : in out Machine_3);	      --  5  Turn on the machine
   procedure Turn_Off (M3 : in out Machine_3);        --  6  Turn off the Machine
   type Machine_4 is new Machine_3 with private;      --  2  
   function Create(S : String := "Machn_4") return Machine_4;
   procedure Turn_On  (M4 : in out Machine_4);	      --  5  Turn on the machine
   procedure Turn_Off (M4 : in out Machine_4);        --  6  Turn off the Machine
   function Get (From : Machine_Set)                  --
                              return Machine'Class;   -- 
private			                              --  8  Begin private part of package
   type Machine is tagged                             --  9 Full tagged definition of message
     record                                           -- 10
       Identifier : String(1..7) := (others => ' ');  --  
       Is_On : Boolean := False;                      -- 11  Machine content; initialized 
     end record;                                      -- 12 End of machine definition
   type Machine_1 is new Machine with null record;    --
   type Machine_2 is new Machine with null record;    --
   type Machine_3 is new Machine_1 with null record;  --
   type Machine_4 is new Machine_3 with null record;  --
end Machinery_For_Streams;	                        -- 13 End of the package specification