-- ==========================================================================================
-- Membership_Example.adb
--
-- See 4.4.2 in Ada Distilled for discussion of the membership testing
--  
--
--
--
-- ==========================================================================================
--
procedure Membership_Example is
   -- This is a wrapper so the procedure will compile

   type Bounded_Integer is new Integer range - 473 .. 451;  -- Derived type; derived from Standard Integer

   procedure Demand	                            --  1 Procedure Identifier 
         (Data : in out Bounded_Integer'Base) is    --  2 Parameter list for Base type
      Local : Bounded_Integer'Base := 0;	          --  3 Initialized variable.
   begin	-- Demand	                            --  4 Comment the begin statement
      Data := Data + Local;	                      --  5 Comment the begin statement
      if Data in Bounded_Integer then               --  6 Simple membership test for a range
         null;		                            --  7 Some Action
      end if;			                      --  8 Always need an end if
   end Demand;		                            --  9  label the end statement

   Number : Bounded_Integer := 42;

begin
   Demand(Number);
end Membership_Example;	                              
