-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Messenger.ads
--
-- See 7.1 in Ada Distilled for discussion of this program.
--
-- 
--
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 

package Messenger is	                                --  1 Package specification; requires body
   type Message is private;                             --  2 Visible part of the data type; name only  
   function Create (S : String) return Message;         --  3 function specification
   procedure Send  (M :  in Message);	              --  4 procedure specification
   procedure Receive (M : out Message);	              --  5 procedure specification
   function  Size (M : in Message) return Natural;      --  6 function specification
private		                                      --  7 private part hidden from a client of contract
   type Message is                                      --  8
      record                                            --  9 full definition of the publicly declared type
         Text   : String (1 .. 120) := (others => ' '); -- 10 string component of the type; OOP attribute 
         Length : Natural           := 0;               -- 11 how many of the 120 values are in use 
      end record;                                       -- 12 scope terminator for the component
end Messenger;	                                      -- 13 scope terminator for the specification