-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Messenger_1.adb
--
-- See 7.1 in Ada Distilled for discussion of this program.
--
-- 
--
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
package Messenger_1 is	                               --  1 An Ada Module
   type Message is private;                            --  2 A partial definition of message
   function Null_Message return Message;	             --  3 Gives a null message
   function Create (S : String) return Message;        --  4 Make a message from a String
   function Get return Message;	                   --  5 Get  message from keyboard
   procedure Put (M : in Message);	                   --  6 Put Message to Screen
   procedure Clear (M : in out Message);               --  7 Set message to null message
   function Text (M : Message) return String;          --  8 The string portion of  message
   function Length (M : Message) return Natural;       --  9 How many of characters
private			                               -- 10 Begin private part of package
   type Message is                                     -- 10.1
      record                                           -- 11 Full definition of message
         Data : String (1 .. 200) := (others => ' ');  -- 12 Message content; initialized 
         Len  : Natural           := 0;                -- 13 Message size; initialized 
      end record;                                      -- 14 End of message definition
end Messenger_1;	                                     -- 15 End of the specification