with Ada.Text_Io; 	                        --  1 Put a library unit in scope and make it directly visible
with Ada.Integer_Text_Io, Ada.Float_Text_Io;    --  2 Predefined numeric IO packages
with Ada.Numerics;	                        --  3 ALRM, Annex A.5
procedure P7 is		                        --  4 Parameterless declaration
   package IIO renames Ada.Integer_Text_Io;     --  5 Make the name shorter via a renames clause
   X : Integer := 42;	                        --  6 In scope for entire procedure
begin				                        --  7 Required to initiate sequence of statements
   IIO.Put(X);		                        --  8 What will print?
   Local_Block:	                              --  9 Always name a declare block
      declare			                  -- 10 begin a new scope (declarative region)
      use Ada.Float_Text_Io;                    -- 11 controversial localization of use clause
      X : Float := Ada.Numerics.Pi;             -- 12 Hide visibility of global Integer, P7.X
   begin			                        -- 13 [optionally Handled ] sequence of statements
      Put(X);		                        -- 14 Put is visible because of  "use clause"
      Iio.Put(P7.X);	                        -- 15 Dot qualifier  makes Integer X visible
   end Local_Block;	                        -- 16 Labeled end  name required for labeled block
   Ada.Text_IO.New_Line;                        -- 17
   Ada.Text_IO.Put_Line("End of Program");      -- 18
end P7;				                  -- 19 Always label a subprogram end statement