-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Accessibility_Problem_3.adb
--
-- See 5.4.2.2 in Ada Distilled for discussion of this program.
--
-- 
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
package body Reference_Types is	                          --  1 
   procedure Process  (Data : in out Data_Set; 	              --  2
         Method : in Process_Method) is 	                    --  3
   begin 		                                            --  4
      for I in Data'range	                                --  5
            loop	                                            --  6
         Method(Data(I));	                                --  7
      end loop;	                                            --  8	
   end Process;	                                            --  9
   function  Validate (Data : access Data_Set;	              -- 10 	
         Validator : in Validate_Routine) return Boolean is	  -- 11
   begin		                                            -- 12
      return Validate(Data.all, Validator);	              -- 13
   end Validate;	                                            -- 14
                                                              -- 15
   function  Validate (Data : in Data_Set;	              -- 16
         Validator : in Validate_Routine) return Boolean is	  -- 17
      Without_Error : Boolean := True;	                    -- 18
   begin		                                            -- 19
      for I in Data'range	                                -- 20
            loop	                                            -- 21
         Without_Error := Validator(Data => Data(I));	        -- 22
         exit when not Without_Error;	                    -- 23
      end loop;	                                            -- 24
      return Without_Error;	                                -- 25
   end Validate; 	                                            -- 26
end Reference_Types;	                                      -- 27