-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Accessibility_Problem_3.adb
--
-- See 5.4.2.2 in Ada Distilled for discussion of this program.
--
-- 
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
package Reference_Types is	                              --  1 
   type Int_32 is range - 2**31 .. 2**31 - 1;               --  2 a signed integer with range
   for  Int_32'Size use 32;	                              --  3 use 32 bits for the integer
   type Data_Set is array (Natural range <>) of Int_32;     --  4 unconstrained array of int_32
   type Data_Set_Reference is access all Data_Set;          --  5 pointer type to the array type
   type Validate_Routine is access function (Data : Int_32) --  6 access type that points to a
      return Boolean;	                                    --  7 function; access to function  
   type Process_Method is access procedure (Data : Int_32);	--  8 access type points to 
   procedure Process  (Data : in out Data_Set;              --  9         this procedure                  
                       Method : in Process_Method);	      -- 10 
   function  Validate (Data : access Data_Set;              -- 11 access parameter;  in mode
      Validator : in Validate_Routine) return Boolean;      -- 12 access to function parameter
   function  Validate (Data : in Data_Set;                  -- 13 access parameter;  in mode
      Validator : in Validate_Routine) return Boolean;      -- 14 access to function parameter
end Reference_Types;	                                    -- 15 