-- ============================================================
-- Stream_Input_For_Machine.adb
--
-- ============================================================
with Ada.Streams.Stream_Io;
use  Ada.Streams;
with Ada.Text_IO;
use  Ada;
with Machinery_For_Streams;
procedure Stream_Input_For_Machine is
   The_File  : Stream_Io.File_Type;
   Reference : Stream_Io.Stream_Access;
   File_Name    : String(1..80) := (others => ' ');
   File_Name_Length : Natural;
begin
   Text_IO.Put("Enter File Name: ");
   Text_IO.Get_Line(File_Name, File_Name_Length);
   Stream_Io.Open(File => The_File,
                    Mode => Stream_IO.In_File,
                    Name => File_Name(1..File_Name_Length));
   Reference := Stream_Io.Stream(The_File);
   while not Stream_Io.End_Of_File (The_File)
       loop
           declare
             Data : Machinery_For_Streams.Machine'Class 
                    := Machinery_For_Streams.
                       Machine'Class'Input(Reference);
           begin
               Machinery_For_Streams.Turn_On(Data);
           end;
       end loop;
   Stream_Io.Close(The_File);
end Stream_Input_For_Machine;