with Ada.Unchecked_Conversion; use Ada;	                 --  1   Chapter 13 or ALRM
procedure Unchecked_Example is 	                 --  2   Generally speaking, don't do this
   type Vector is array (1 .. 4) of Integer; 	     --  3   Array with four components
   for Vector'Size use 4 * Integer'Size;             --  4   Define number of bits for the array
   type Data is                                      --  5.1 A record with four components
      record                                         --  5.2
         V1 : Integer;                               --  5.3
         V2 : Integer;                               --  5.4
         V3 : Integer;                               --  5.5  
         V4 : Integer;                               --  6   
      end record;                                    --  7
   for Data'Size use 4 * Integer'Size;               --  8  Same number of bits as the array
   function Convert is new Unchecked_Conversion	     --  9
      (Source => Vector, Target => Data);            -- 10  Convert a Vector to a Data
   The_Vector : Vector := (2, 4, 6, 8);              -- 11  Intilialize a Vector with values
   The_Data   : Data   := (1, 3, 5, 7);              -- 12  Intilialize a Record with values
begin		                                         -- 13
   The_Data := Convert(The_Vector);                  -- 14  Assignment via unchecked conversion
end Unchecked_Example;	                             -- 15