with Ada.Text_IO;
with Ada.Strings.Fixed;
--with Ada.Strings.Maps;
with Ada.Characters.Handling;
use  Ada.Strings;
use  Ada;
package body Attribute_Experiment_Declarations is

   package Real_IO is new Text_IO.Float_IO(Num => Real);

   procedure Put(To : out String; Item : in Real; Aft : Text_IO.Field := 5; Exp : Text_IO.Field := 0)
            renames Real_IO.Put;

   function Purge_Control_Characters(The_String : String) return String is
      Result : String(The_String'Range) := The_String;
   begin
      for I in Result'Range
            loop
               if Characters.Handling.Is_Control(Result(I)) then
                   Result(I) := Strings.Space;
               end if;
            end loop; 
      return Result;
   end Purge_Control_Characters; 

   package body Catenator is

      function "&" (L : Real; R : String) return String is
         Real_String : String(1..12) := (others => ' ');
         Real_String_Index : Natural; 
         Result      : String(1..80) := (others => ' ');
      begin
         Put(To => Real_String, Item => L);
         Real_String_Index := Fixed.Index_Non_Blank(Real_String);
         Fixed.Move(Source => Real_String (1..Real_String_Index + 1),
                              Target => Result, Justify => Left); 
         Fixed.Replace_Slice(Source => Result, Low => Real_String_Index + 2,
                             High   => Result'Last,
                             By     => R); 
         return Purge_Control_Characters(Result);
      end "&";

      function "&" (L : String; R : Real) return String is
         Real_String : String(1..12) := (others => ' ');
         Real_String_Index : Natural;
         Result      : String(1..80) := (others => ' ');
      begin
         Put(To => Real_String, Item => R);
         Real_String_Index := Fixed.Index_Non_Blank(Real_String);
         Fixed.Move(Source => L, Target => Result, Justify => Left); 
         Fixed.Replace_Slice(Source => Result, Low => L'Last + 2,
                             High   => Result'Last, 
                             By     => Real_String);
         return Purge_Control_Characters(Result);
      end "&";

   end Catenator;
   
  
--  procedure Put(Item : Real; Fore : Natural := 6; Aft : Natural := 5; Exp : Natural := 0)
--                        renames Real_IO.Put;
--                        
--  procedure Put(Label : String; Item : Real);

   
   function Get (Prompt : String) return Real is
      Result : Real;
   begin
      Text_IO.Put(Prompt & " = ");
      Real_IO.Get(Result);
      return Result;
   end Get;

--   procedure Put (Label : String; Item : Real) is
--     use Catenator;
--   begin
--      Text_IO.Put_Line(Label & Item);
--   end Put;

   procedure Put (Result : String) is
   begin
      Text_IO.Put_Line(Result);
   end Put;

end Attribute_Experiment_Declarations;

